%define current_version 1.0.87

Name:		vz-guest-tools-updater
Version:	%{current_version}
Release:        1%{?dist}
Summary:	A tool to trigger VM guest tools update

Group:		System Environment/Base
License:	GPLv2
Source0:	%{name}-%{version}.tar.bz2
Source1:	tools-update.conf
Source2:	%{name}.service
Source3:	%{name}.timer
Source4:	%{name}.cron
BuildArch:	noarch
Requires:	libprlsdk-python
Requires:	libvirt-python
Requires:	python-lxml
Requires:	python-libguestfs
Requires:	libguestfs-tools-c

Requires(preun): systemd-units
Requires(postun): systemd-units
Requires(post): systemd-units

%description
A tool to trigger automated guest tools updates inside VMs.

%prep
%setup -q

%install
install -D -m755 vz-guest-tools-updater.py %{buildroot}%{_bindir}/%{name}
install -D -m644 vz-guest-tools-install.lnk %{buildroot}%{_datadir}/%{name}/vz-guest-tools-install.lnk
install -D -m644 %{SOURCE1} %{buildroot}%{_sysconfdir}/vz/tools-update.conf
install -D -m644 %{SOURCE4} %{buildroot}%{_sysconfdir}/cron.d/%{name}
mkdir -p %{buildroot}/lib/systemd/system
for unit in %{SOURCE2} %{SOURCE3}; do
    install -m 644 $unit %{buildroot}/lib/systemd/system/
done

mkdir -p %{buildroot}/var/lib
echo '{}' > %{buildroot}/var/lib/vz-guest-tools-updater.json

%post
for unit in service timer; do
    %systemd_post %{name}.$unit
done
systemctl is-enabled -q %{name}.timer && systemctl start %{name}.timer || :

%preun
for unit in service timer; do
    %systemd_preun %{name}.$unit
done

%postun
%systemd_postun

%files
%{_bindir}/*
%{_datadir}/%{name}/*
%{_sysconfdir}/vz/*conf
%{_sysconfdir}/cron.d/*
/lib/systemd/system/*
%config(noreplace) /var/lib/vz-guest-tools-updater.json

%changelog
* Mon Apr 01 2019 Denis Silakov <dsilakov@virtuozzo.com> 1.0.87
 - fix for #PSBM-93200, need to pass proper ID to supported_guest platforms
(Alexander Stefanov <astefanov@virtuozzo.com>)

* Tue Mar 26 2019 Denis Silakov <dsilakov@virtuozzo.com> 1.0.86
 - Fix detection of centos6
 - Do not fail if db file is compeltely missing, PSBM-92953
 - Avoid unneeded warnings, PSBM-92901
 - One more fix for guest detection

* Fri Mar 22 2019 Denis Silakov <dsilakov@virtuozzo.com> 1.0.85
 - Do not fail if db file is compeltely missing, PSBM-92953
 - Avoid unneeded warnings, PSBM-92901
 - One more fix for guest detection

* Fri Mar 22 2019 Denis Silakov <dsilakov@virtuozzo.com> 1.0.84
 - Avoid unneeded warnings, PSBM-92901
 - One more fix for guest detection

* Fri Mar 22 2019 Denis Silakov <dsilakov@virtuozzo.com> 1.0.83
 - One more fix for guest detection

* Tue Mar 05 2019 Denis Silakov <dsilakov@virtuozzo.com> 1.0.82
 - Added virtuozzo ID support

* Tue Mar 05 2019 Denis Silakov <dsilakov@virtuozzo.com> 1.0.81
 - Improve centos/rhel detection, PSBM-88107

* Wed Dec 19 2018 Denis Silakov <dsilakov@virtuozzo.com> 1.0.80
 - Ignore VM if failed to get its info, PSBM-90356

* Thu Oct 25 2018 Denis Silakov <dsilakov@virtuozzo.com> 1.0.79-3
 - Drop requisite, as well. Works unexpectedly, see #PSBM-89652

* Wed Oct 24 2018 Denis Silakov <dsilakov@virtuozzo.com> 1.0.79-2
 - Use Requisite instead of Wants, see #PSBM-89624

* Thu Oct 18 2018 Denis Silakov <dsilakov@virtuozzo.com> 1.0.79
 - PSBM-89493

* Fri Sep 21 2018 Konstantin Volkov <wolf@virtuozzo.com> 1.0.78-2
- Correct prl-disp requirements, see #PSBM-82130

* Tue Sep 11 2018 Denis Silakov <dsilakov@virtuozzo.com> 1.0.78
 - PSBM-87080
 - PSBM-88107
 - PSBM-88550

* Tue Sep 11 2018 Denis Silakov <dsilakov@virtuozzo.com> 1.0.77
 - PSBM-88107
 - PSBM-88550

* Tue Sep 11 2018 Denis Silakov <dsilakov@virtuozzo.com> 1.0.76
 - PSBM-88550

* Mon Sep 10 2018 Denis Silakov <dsilakov@virtuozzo.com> 1.0.75
 - Use absolute path for tools in subprocess
 - Add libguestfs-tools-c requirement for virt-sysprep

* Wed Jul 25 2018 Denis Silakov <denis.silakov@rosalab.ru> 1.0.73-3
 - Start only timer, not service, #PSBM-87042

* Tue Jul 17 2018 Denis Silakov <denis.silakov@rosalab.ru> 1.0.73-2
 - Force service & timer start if they are enabled, #PSBM-86568

* Tue May 08 2018 Denis Silakov <denis.silakov@rosalab.ru> 1.0.73
 - Rework guest system type-version check as described in PSBM-83281|
 - Fix return status (kirill.trushkin <kirill.trushkin@virtuozzo.com>)
 - Fix remarks (kirill.trushkin <kirill.trushkin@virtuozzo.com>)
 - Fixed remarks (kirill.trushkin <kirill.trushkin@virtuozzo.com>)
 - Add check for guest disto version (kirill.trushkin
<kirill.trushkin@virtuozzo.com>)

* Sun Apr 08 2018 Denis Silakov <denis.silakov@rosalab.ru> 1.0.71
 - Added InstallTools option to config, PSBM-82989
 - Added InstallTools option to config, PSBM-82989

* Fri Feb 16 2018 Denis Silakov <dsilakov@virtuozzo.com> 1.0.68
 - PSBM-81442

* Sat Feb 10 2018 Denis Silakov <dsilakov@virtuozzo.com> 1.0.67
 - Disable guest.set_event_callback for libguestfs, crashes atm - see PSBM-81441

* Mon Jan 29 2018 Denis Silakov <dsilakov@virtuozzo.com> 1.0.66
 - PSBM-78999 (Konstantin Vlasov <kvlasov@virtuozzo.com>)

* Wed Dec 06 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.65
 - PSBM-78694

* Tue Dec 05 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.64
 - PSBM-75760 (Konstantin Vlasov <kvlasov@virtuozzo.com>)

* Mon Dec 04 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.63
 - Enable autoinstall

* Thu Nov 30 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.62
 - PSBM-77630
 - PSBM-77223

* Wed Nov 08 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.60
 - PSBM-76887

* Wed Nov 01 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.59
 - vz-guest-tools-updater.py: Fix missing parenthesis (Vitaly Ostrosablin
<vostrosablin@virtuozzo.com>) (#PSBM-76523)

* Tue Oct 31 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.58
 - Update udev rule together with install-tools script, see #PSBM-76087
 - Fixed invalid cdroms failing; fixed write on disk not working (Konstantin
Vlasov <kvlasov@virtuozzo.com>)

* Wed Oct 25 2017 Konstantin Vlasov <konstantin.vlasov@virtuozzo.com> 1.0.57-2
 - Fixed missing Windows LNK file
 
* Wed Oct 25 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.57
 - Save guestfs events logs to syslog when debugging

* Wed Oct 25 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.56
 - Disable tools autoinstall for now, experiment with 'sleep' for #PSBM-76001
 - Fixed path to Windows LNK file (Konstantin Vlasov <kvlasov@virtuozzo.com>)

* Tue Oct 24 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.54
 - Fix typo

* Mon Oct 23 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.53
 - Use add_libvirt_dom instead of add_drive, see #PSBM-75846

* Mon Oct 23 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.52
 - Add guestfs verbose logging if --debug is set, see #PSBM-75851

* Mon Oct 23 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.51
 - Always update install-tools, see #PSBM-75555
 - Update install-tools script for releases earlier than 120, see #PSBM-75430

* Mon Oct 23 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.50
 - Update install-tools script for releases earlier than 120, see #PSBM-75430

* Thu Oct 19 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.49
 - Reuse already mounted guest tools cd (#PSBM-75678), avoid parallel launch

* Tue Oct 17 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.48
 - Ensure that install-tools is executable, see #PSBM-75302

* Thu Oct 05 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.47
 - More graceful handling of guestfs failures, see #PSBM-72594

* Fri Sep 29 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.46
 - Exit if failed to connect to dispatcher
 - Add exception handler and logging for dispatcher connection procedure, see
\#PSBM-72540 (Konstantin Volkov <wolf@virtuozzo.com>)

* Tue Sep 26 2017 Denis Silakov <denis.silakov@rosalab.ru> 1.0.45
 - Fix Pythonish
 - Revert "Drop unintentional changes, see #PSBM-72996"

* Mon Sep 25 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.43
 - Drop unintentional changes, see #PSBM-72996
 - Drop unintentional changes

* Mon Sep 25 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.42
 - Fix crash in case when ve doesn't have tools installed, be a bit more
Pythonish, see#PSBM-72887

* Tue Sep 12 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.41
 - Force preliminary upgrade of install-tools script for tools 0.10-115 and
earlier, see #PSBM-71805
 - Minor string value deduplication (Konstantin Vlasov <kvlasov@virtuozzo.com>)

* Thu Sep 07 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.40
 - Minor string value deduplication (Konstantin Vlasov <kvlasov@virtuozzo.com>)

* Thu Sep 07 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.39
 - Fixed missing umounts (Konstantin Vlasov <kvlasov@virtuozzo.com>)
 - Added offline GT installation for Windows, #PSBM-39576 (Konstantin Vlasov
<kvlasov@virtuozzo.com>)

* Fri Sep 01 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.38
 - Implemented tools installation for VMs without tools, see #PSBM-39576

* Fri Aug 25 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.37
 - Fix check for running installer, see #PSBM-70732

* Thu Aug 24 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.36
 - Rework processing of machines without install-tools and with bad udev, see
\#PSBM-70534
 - Fix tools release processing, do not fail if can't get integer from it, see
\#PSBM-70561

* Wed Aug 23 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.35
 - Fix tools release processing, do not fail if can't get integer from it, see
\#PSBM-70561

* Fri Jul 21 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.34
 - Report if virsh fails to eject iso, add timeout after eject, #PSBM-68834
 - Fix check for Debian 7 in udev_guest

* Mon Jul 17 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.33
 - Fix fail on missing key on ve_db, see #PSBM=68547
 - Use iso_found variable out of scope (<pbutsykin@virtuozzo.com>)

* Tue Jun 27 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.32
 - Use iso_found variable out of scope (<pbutsykin@virtuozzo.com>)

* Wed Jun 14 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.31
 - Fix update from versions that were subjected to timeout issue (#PSBM-67245)

* Fri Jun 09 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.30
 - Avoid unneeded message about max VMs reached if there are nno more VMs to
process (#PSBM-66088)

* Wed Jun 07 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.29
 - Improve get-state output
 - Implement --get-state option (#PSBM-66437)

* Wed Jun 07 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.28
 - Implement --get-state option (#PSBM-66437)

* Wed May 17 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.27
 - Fix typo (#PSBM-66417)
 - Take update_exec return value into account
 - Added more logging, umount cd after copying install-tools from it if we are
not going to call them explicitly

* Wed May 17 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.26
 - Take update_exec return value into account
 - Added more logging, umount cd after copying install-tools from it if we are
not going to call them explicitly

* Fri Apr 28 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.24
 - Workaround for missing install-tools, #PSBM-65654 (Konstantin Vlasov
<kvlasov@virtuozzo.com>)

* Thu Apr 27 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.23
 - Treat all tools with 2.5* version as 'bad udev', fix processing of vms with
auto-update set to off, add more logging

* Wed Apr 19 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.22
 - Deb 7 suffers from the same udev problem as CentOS 6 (#PSBM-64906)
 - Fix typo in CentOS 6 detection (#PSBM-64889)
 - Force overwrite of  install-tools script when updating through exec
(#PSBM-64116)
 - More logging for #PSBM-64116

* Wed Apr 19 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.21
 - Fix typo in CentOS 6 detection (#PSBM-64889)

* Tue Apr 18 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.20
 - Force overwrite of  install-tools script when updating through exec
(#PSBM-64116)
 - More logging for #PSBM-64116

* Tue Apr 18 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.19
 - More logging for #PSBM-64116

* Tue Apr 11 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.18
 - Force ejection of guest tools media (#PSBM-60093)

* Thu Apr 06 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.17
 - Fix check for CentOS 6 (#PSBM-63881)

* Thu Apr 06 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.16
 - Fix processing of empty types (#PSBM-63655)

* Mon Apr 03 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.15
 - Do not fail if 'type' is missing in json (#PSBM-63468)

* Mon Apr 03 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.14
 - Fix check for guests with bad udev, do not check win guests for this
(#PSBM-63416)

* Fri Mar 31 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.13
 - Fix 'force' usage (#PSBM-63220)

* Fri Mar 31 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.12
 - Improve checking for guests where our udev rule doesn't work (#PSBM-63222)

* Thu Mar 30 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.11
 - Disconnect guest tools CD before running 'installtools' (#PSBM-60093)

* Wed Mar 29 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.10
 - Improve logging for disp-helper

* Mon Mar 27 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.9
 - Added hack for CentOS 6 (#PSBM-60786)

* Mon Mar 27 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.8
 - Fix launch with empty json
 - Create empty vz-guest-tools-updater.json by default

* Mon Mar 27 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.7
 - Implement update-through-exec (#PSBM-61938) 

* Mon Mar 27 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.5-2
- Fix lost guest_os_name (#PSBM-62973)

* Wed Mar 23 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.5-1
- Drop 'failed' flag once we detect that the tools were updated (#PSBM-62449)

* Mon Mar 20 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.4-2
- Add help (#PSBM-62504)
- Stop vz-guest-tools-updater.timer if prl-disp is stopped (#PSBM-62413)
- If VMs for update are specified in cmdline, process them even if
  'autoupdate' set to 'no' (#PSBM-62416) and even if they are not present
  in json (#PSBM-62460)
- Remove VMs that no longer exist from the json file (#PSBM-62401)

* Mon Mar 13 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.3
- Start service after prl-disp (#PSBM-62109)

* Fri Mar 10 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.2
- Make data collection a separate process

* Thu Mar 09 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.1
- Allow passing VM names/uuid as script parameters

* Tue Mar 07 2017 Denis Silakov <dsilakov@virtuozzo.com> 1.0.0
 - Initial build of vz-guest-tools-updater package (#PSBM-17703)
